using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace ConvertResX
{
    // Limitations:-
    //              ConvertResX cannot read resx files that cannot be de-serialized. This would be the case if the resx file contained unknown types.
    class Program
    {
        static void Main(string[] args)
        {
            bool overWrite = (args.GetLength(0) >= 3 && String.Compare(args[2], "/OVERWRITE", StringComparison.OrdinalIgnoreCase) == 0);
            if (args.GetLength(0) < 2)
                ShowSyntax();
            else if (!File.Exists(args[0]))
            {
                ShowSyntax();
                System.Console.WriteLine(String.Format("{0} input file does not exist", args[0]));
            }
            else if (File.Exists(args[1]) && !overWrite)
            {
                ShowSyntax();
                System.Console.WriteLine(String.Format("{0} output file already exists", args[1]));
            }
            else
            {
                System.Console.WriteLine("ConvertResX");
                System.Console.WriteLine("");
                Internationalization.Tools.ConvertResX.Convert(args[0], args[1]);
                System.Console.WriteLine(String.Format("Converted {0} to {1}.", args[0], args[1]));
            }
        }
        private static void ShowSyntax()
        {
            System.Console.WriteLine("ConvertResX converts resx files from .NET Framework 2.0 resx files to .NET Framework 1 resx files");
            System.Console.WriteLine("");
            System.Console.WriteLine("ConvertResX <InputResXFile> <OutputResXFile> [/OverWrite]");
            System.Console.WriteLine("");
            System.Console.WriteLine(@"ConvertResX \VS2005\Form1.resx \VS2003\Form1.resx /OverWrite");
            System.Console.WriteLine("");
            System.Console.WriteLine(@"!!! Backup your files before using this utility !!!");
            System.Console.WriteLine("");
        }
    }
}
