// File           : MainForm.cs 
// Original Author: Guy Smith-Ferrier
// Date Created   : September 2006
// Notes          : This file is part of the downloadable source code for .NET Internationalization, by
//                  Guy Smith-Ferrier, published by Addison-Wesley. See http://www.dotneti18n.com for details.
// Disclaimer     : No warranty is provided. Use at your own risk.
// Modification   : You are free to modify this code providing that this block of comments is not altered
//                  and is placed before any code.
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Internationalization.Windows.Forms;
using Internationalization;

namespace HotKeyAssignmentsExample
{
    /// <summary>
    /// MainForm provides a demonstration of using the Windows Forms HotKeyAssignments class
    /// </summary>
    public partial class MainForm : Form
    {
        /// <summary>
        /// Constructs a MainForm object
        /// </summary>
        public MainForm()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            Form1 form = new Form1();
            if (checkBoxApplyHotKeyAssignments.Checked)
                HotKeyAssignment.AssignHotKeys(form, checkBoxPreserveExistingHotKeys.Checked);
            form.Show();
        }

        private void checkBoxIgnoreAcceptAndCancelButtons_CheckedChanged(object sender, EventArgs e)
        {
            HotKeyAssignment.IgnoreAcceptAndCancelButtons = checkBoxIgnoreAcceptAndCancelButtons.Checked;
        }

        private void radioButton1_CheckedChanged(object sender, EventArgs e)
        {
            HotKeyAssignment.Format = HotKeyFormat.Culture;
        }

        private void radioButton2_CheckedChanged(object sender, EventArgs e)
        {
            HotKeyAssignment.Format = HotKeyFormat.Embedded;
        }

        private void radioButton3_CheckedChanged(object sender, EventArgs e)
        {
            HotKeyAssignment.Format = HotKeyFormat.SimpleEmbedded;
        }

        private void radioButton4_CheckedChanged(object sender, EventArgs e)
        {
            HotKeyAssignment.Format = HotKeyFormat.BracketedSuffix;
        }

        private void radioButton5_CheckedChanged(object sender, EventArgs e)
        {
            HotKeyAssignment.Format = HotKeyFormat.BracketedPrefix;
        }

        private void radioButton6_CheckedChanged(object sender, EventArgs e)
        {
            HotKeyAssignment.Format = HotKeyFormat.BracketedSuffixEmbedded;
        }

        private void radioButton7_CheckedChanged(object sender, EventArgs e)
        {
            HotKeyAssignment.Format = HotKeyFormat.BracketedPrefixEmbedded;
        }

        private void buttonAddStandardHotKeys_Click(object sender, EventArgs e)
        {
            HotKeyAssignment.AddStandardHotKeys("O:OK;C:Cancel");
        }
    }
}