// File           : ResXResourceManager.cs
// Original Author: Guy Smith-Ferrier
// Date Created   : September 2005
// Notes          : This file is part of the downloadable source code for .NET Internationalization, by
//                  Guy Smith-Ferrier, published by Addison-Wesley. See http://www.dotneti18n.com for details.
// Disclaimer     : No warranty is provided. Use at your own risk.
// Modification   : You are free to modify this code providing that this block of comments is not altered
//                  and is placed before any code.
using System;
using System.Reflection;

namespace Internationalization.Resources
{
    /// <summary>
    /// ResXResourceManager is a resource manager for reading and writing resources in .resx files
    /// </summary>
    public class ResXResourceManager : ResourcesResourceManager
	{
        /// <summary>
        /// Initialize initializes the new object
        /// </summary>
        /// <param name="baseName">The qualified base name which the resources represent</param>
        /// <param name="assembly">assembly is not used in this implementation</param>
        protected override void Initialize(string baseName, Assembly assembly)
		{
			Extension = "resx";
			base.Initialize(baseName, assembly);
		}
        /// <summary>
        /// Constructs a ResXResourceManager object
        /// </summary>
        /// <param name="baseName">The qualified base name which the resources represent</param>
        /// <param name="assembly">assembly is not used in this implementation</param>
        public ResXResourceManager(string baseName, Assembly assembly)
            : base(baseName, assembly)
		{
		}
        /// <summary>
        /// Constructs a ResXResourceManager object
        /// </summary>
        /// <param name="baseName">The qualified base name which the resources represent</param>
        public ResXResourceManager(string baseName)
            : base(baseName)
		{
		}
        /// <summary>
        /// Constructs a ResXResourceManager object
        /// </summary>
        /// <param name="resourceType">The Type for which resources should be read/written</param>
        public ResXResourceManager(Type resourceType)
            : base(resourceType)
		{
		}
	}
}
