// File           : Form1.cs
// Original Author: Guy Smith-Ferrier
// Date Created   : September 2005
// Notes          : This file is part of the downloadable source code for .NET Internationalization, by
//                  Guy Smith-Ferrier, published by Addison-Wesley. See http://www.dotneti18n.com for details.
// Disclaimer     : No warranty is provided. Use at your own risk.
// Modification   : You are free to modify this code providing that this block of comments is not altered
//                  and is placed before any code.
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Globalization;
using System.Reflection;
using System.Data.SqlClient;
using System.Resources;
using System.IO;
using Internationalization.Resources;
using Internationalization.Translation;

namespace CustomResourceManagersExample
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.GroupBox groupBoxTranslationResourceManager;
		private System.Windows.Forms.Button button10;
		private System.Windows.Forms.Button button11;
		private System.Windows.Forms.Button button12;
		private System.Windows.Forms.Button button13;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.Button button6;
		private System.Windows.Forms.Button button7;
		private System.Windows.Forms.Button button8;
		private System.Windows.Forms.Button button9;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.Button button5;
		private System.Windows.Forms.Button button4;
		private System.Windows.Forms.Button button3;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.GroupBox groupBox3;
		private System.Windows.Forms.RadioButton radioButtonDbResourceManager;
		private System.Windows.Forms.RadioButton radioButtonResourcesResourceManager;
		private System.Windows.Forms.RadioButton radioButtonTranslationResourceManager;
		private System.Windows.Forms.Button button14;
		private System.Windows.Forms.GroupBox groupBox4;
		private System.Windows.Forms.RadioButton radioButtonTRMResourceManager;
		private System.Windows.Forms.RadioButton radioButtonTRMResourcesResourceManager;
		private System.Windows.Forms.RadioButton radioButtonTRMDbResourceManager;
		private System.Windows.Forms.Button button15;
		private System.Windows.Forms.RadioButton radioButtonResourceManager;
        private System.Windows.Forms.GroupBox groupBox5;
        private System.Windows.Forms.Label label1;
        private System.Windows.Forms.TextBox textBoxCurrentUICulture;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

        /// <summary>
        /// Constructs a Form1 object
        /// </summary>
        public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

            // DbResourceManager.ConnectionString = @"server=localhost\SQLEXPRESS;database=CustomResourceManagersExample;trusted_connection=true";

			TranslationResourceManager.ResourceManagerType = typeof(DbResourceManager);		
			TranslationResourceManager.Translators = new TranslatorCollection();
			TranslationResourceManager.Translators.Add(new PseudoTranslator());
			TranslationResourceManager.Translators.Add(new WebServiceXTranslator());
			TranslationResourceManager.Translators.Add(new CloserFarTranslator());

			ResourceManagerProvider.ResourceManagerType = typeof(DbResourceManager);
            ShowCurrentUICulture();
		}
        private void ShowCurrentUICulture()
        {
            textBoxCurrentUICulture.Text = CultureInfo.CurrentUICulture.Name;
        }

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.groupBoxTranslationResourceManager = new System.Windows.Forms.GroupBox();
            this.groupBox4 = new System.Windows.Forms.GroupBox();
            this.radioButtonTRMResourceManager = new System.Windows.Forms.RadioButton();
            this.radioButtonTRMResourcesResourceManager = new System.Windows.Forms.RadioButton();
            this.radioButtonTRMDbResourceManager = new System.Windows.Forms.RadioButton();
            this.button10 = new System.Windows.Forms.Button();
            this.button11 = new System.Windows.Forms.Button();
            this.button12 = new System.Windows.Forms.Button();
            this.button13 = new System.Windows.Forms.Button();
            this.groupBox2 = new System.Windows.Forms.GroupBox();
            this.button6 = new System.Windows.Forms.Button();
            this.button7 = new System.Windows.Forms.Button();
            this.button8 = new System.Windows.Forms.Button();
            this.button9 = new System.Windows.Forms.Button();
            this.groupBox1 = new System.Windows.Forms.GroupBox();
            this.button2 = new System.Windows.Forms.Button();
            this.button5 = new System.Windows.Forms.Button();
            this.button4 = new System.Windows.Forms.Button();
            this.button3 = new System.Windows.Forms.Button();
            this.button14 = new System.Windows.Forms.Button();
            this.textBox1 = new System.Windows.Forms.TextBox();
            this.button1 = new System.Windows.Forms.Button();
            this.groupBox3 = new System.Windows.Forms.GroupBox();
            this.radioButtonResourceManager = new System.Windows.Forms.RadioButton();
            this.radioButtonTranslationResourceManager = new System.Windows.Forms.RadioButton();
            this.radioButtonResourcesResourceManager = new System.Windows.Forms.RadioButton();
            this.radioButtonDbResourceManager = new System.Windows.Forms.RadioButton();
            this.button15 = new System.Windows.Forms.Button();
            this.groupBox5 = new System.Windows.Forms.GroupBox();
            this.textBoxCurrentUICulture = new System.Windows.Forms.TextBox();
            this.label1 = new System.Windows.Forms.Label();
            this.groupBoxTranslationResourceManager.SuspendLayout();
            this.groupBox4.SuspendLayout();
            this.groupBox2.SuspendLayout();
            this.groupBox1.SuspendLayout();
            this.groupBox3.SuspendLayout();
            this.groupBox5.SuspendLayout();
            this.SuspendLayout();
            // 
            // groupBoxTranslationResourceManager
            // 
            this.groupBoxTranslationResourceManager.Controls.Add(this.groupBox4);
            this.groupBoxTranslationResourceManager.Controls.Add(this.button10);
            this.groupBoxTranslationResourceManager.Controls.Add(this.button11);
            this.groupBoxTranslationResourceManager.Controls.Add(this.button12);
            this.groupBoxTranslationResourceManager.Controls.Add(this.button13);
            this.groupBoxTranslationResourceManager.Location = new System.Drawing.Point(592, 144);
            this.groupBoxTranslationResourceManager.Name = "groupBoxTranslationResourceManager";
            this.groupBoxTranslationResourceManager.Size = new System.Drawing.Size(312, 288);
            this.groupBoxTranslationResourceManager.TabIndex = 14;
            this.groupBoxTranslationResourceManager.TabStop = false;
            this.groupBoxTranslationResourceManager.Text = "TranslationResourceManager";
            // 
            // groupBox4
            // 
            this.groupBox4.Controls.Add(this.radioButtonTRMResourceManager);
            this.groupBox4.Controls.Add(this.radioButtonTRMResourcesResourceManager);
            this.groupBox4.Controls.Add(this.radioButtonTRMDbResourceManager);
            this.groupBox4.Location = new System.Drawing.Point(8, 184);
            this.groupBox4.Name = "groupBox4";
            this.groupBox4.Size = new System.Drawing.Size(296, 96);
            this.groupBox4.TabIndex = 16;
            this.groupBox4.TabStop = false;
            this.groupBox4.Text = "TranslationResourceManager.ResourceManagerType";
            // 
            // radioButtonTRMResourceManager
            // 
            this.radioButtonTRMResourceManager.Location = new System.Drawing.Point(16, 64);
            this.radioButtonTRMResourceManager.Name = "radioButtonTRMResourceManager";
            this.radioButtonTRMResourceManager.Size = new System.Drawing.Size(184, 24);
            this.radioButtonTRMResourceManager.TabIndex = 2;
            this.radioButtonTRMResourceManager.Text = "ResourceManager";
            this.radioButtonTRMResourceManager.CheckedChanged += new System.EventHandler(this.radioButtonTRMResourceManager_CheckedChanged);
            // 
            // radioButtonTRMResourcesResourceManager
            // 
            this.radioButtonTRMResourcesResourceManager.Location = new System.Drawing.Point(16, 40);
            this.radioButtonTRMResourcesResourceManager.Name = "radioButtonTRMResourcesResourceManager";
            this.radioButtonTRMResourcesResourceManager.Size = new System.Drawing.Size(184, 24);
            this.radioButtonTRMResourcesResourceManager.TabIndex = 1;
            this.radioButtonTRMResourcesResourceManager.Text = "ResourcesResourceManager";
            this.radioButtonTRMResourcesResourceManager.CheckedChanged += new System.EventHandler(this.radioButtonTRMResourcesResourceManager_CheckedChanged);
            // 
            // radioButtonTRMDbResourceManager
            // 
            this.radioButtonTRMDbResourceManager.Checked = true;
            this.radioButtonTRMDbResourceManager.Location = new System.Drawing.Point(16, 16);
            this.radioButtonTRMDbResourceManager.Name = "radioButtonTRMDbResourceManager";
            this.radioButtonTRMDbResourceManager.Size = new System.Drawing.Size(184, 24);
            this.radioButtonTRMDbResourceManager.TabIndex = 0;
            this.radioButtonTRMDbResourceManager.Text = "DbResourceManager";
            this.radioButtonTRMDbResourceManager.CheckedChanged += new System.EventHandler(this.radioButtonTRMDbResourceManager_CheckedChanged);
            // 
            // button10
            // 
            this.button10.Location = new System.Drawing.Point(8, 56);
            this.button10.Name = "button10";
            this.button10.Size = new System.Drawing.Size(256, 23);
            this.button10.TabIndex = 11;
            this.button10.Text = "Good Morning";
            this.button10.Click += new System.EventHandler(this.button10_Click);
            // 
            // button11
            // 
            this.button11.Location = new System.Drawing.Point(8, 152);
            this.button11.Name = "button11";
            this.button11.Size = new System.Drawing.Size(256, 23);
            this.button11.TabIndex = 14;
            this.button11.Text = "Good Evening Twice";
            this.button11.Click += new System.EventHandler(this.button11_Click);
            // 
            // button12
            // 
            this.button12.Location = new System.Drawing.Point(8, 120);
            this.button12.Name = "button12";
            this.button12.Size = new System.Drawing.Size(256, 23);
            this.button12.TabIndex = 13;
            this.button12.Text = "Good Evening";
            this.button12.Click += new System.EventHandler(this.button12_Click);
            // 
            // button13
            // 
            this.button13.Location = new System.Drawing.Point(8, 88);
            this.button13.Name = "button13";
            this.button13.Size = new System.Drawing.Size(256, 23);
            this.button13.TabIndex = 12;
            this.button13.Text = "Good Afternoon";
            this.button13.Click += new System.EventHandler(this.button13_Click);
            // 
            // groupBox2
            // 
            this.groupBox2.Controls.Add(this.button6);
            this.groupBox2.Controls.Add(this.button7);
            this.groupBox2.Controls.Add(this.button8);
            this.groupBox2.Controls.Add(this.button9);
            this.groupBox2.Location = new System.Drawing.Point(296, 144);
            this.groupBox2.Name = "groupBox2";
            this.groupBox2.Size = new System.Drawing.Size(288, 184);
            this.groupBox2.TabIndex = 13;
            this.groupBox2.TabStop = false;
            this.groupBox2.Text = "ResourcesResourceManager";
            // 
            // button6
            // 
            this.button6.Location = new System.Drawing.Point(12, 56);
            this.button6.Name = "button6";
            this.button6.Size = new System.Drawing.Size(260, 23);
            this.button6.TabIndex = 7;
            this.button6.Text = "Good Morning";
            this.button6.Click += new System.EventHandler(this.button6_Click);
            // 
            // button7
            // 
            this.button7.Location = new System.Drawing.Point(12, 152);
            this.button7.Name = "button7";
            this.button7.Size = new System.Drawing.Size(260, 23);
            this.button7.TabIndex = 10;
            this.button7.Text = "Good Evening Twice";
            this.button7.Click += new System.EventHandler(this.button7_Click);
            // 
            // button8
            // 
            this.button8.Location = new System.Drawing.Point(12, 120);
            this.button8.Name = "button8";
            this.button8.Size = new System.Drawing.Size(260, 23);
            this.button8.TabIndex = 9;
            this.button8.Text = "Good Evening";
            this.button8.Click += new System.EventHandler(this.button8_Click);
            // 
            // button9
            // 
            this.button9.Location = new System.Drawing.Point(12, 88);
            this.button9.Name = "button9";
            this.button9.Size = new System.Drawing.Size(260, 23);
            this.button9.TabIndex = 8;
            this.button9.Text = "Good Afternoon";
            this.button9.Click += new System.EventHandler(this.button9_Click);
            // 
            // groupBox1
            // 
            this.groupBox1.Controls.Add(this.button2);
            this.groupBox1.Controls.Add(this.button5);
            this.groupBox1.Controls.Add(this.button4);
            this.groupBox1.Controls.Add(this.button3);
            this.groupBox1.Controls.Add(this.button14);
            this.groupBox1.Location = new System.Drawing.Point(8, 144);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Size = new System.Drawing.Size(280, 184);
            this.groupBox1.TabIndex = 12;
            this.groupBox1.TabStop = false;
            this.groupBox1.Text = "DbResourceManager";
            // 
            // button2
            // 
            this.button2.Location = new System.Drawing.Point(16, 56);
            this.button2.Name = "button2";
            this.button2.Size = new System.Drawing.Size(256, 23);
            this.button2.TabIndex = 3;
            this.button2.Text = "Good Morning";
            this.button2.Click += new System.EventHandler(this.button2_Click);
            // 
            // button5
            // 
            this.button5.Location = new System.Drawing.Point(16, 152);
            this.button5.Name = "button5";
            this.button5.Size = new System.Drawing.Size(256, 23);
            this.button5.TabIndex = 6;
            this.button5.Text = "Good Evening Twice";
            this.button5.Click += new System.EventHandler(this.button5_Click);
            // 
            // button4
            // 
            this.button4.Location = new System.Drawing.Point(16, 120);
            this.button4.Name = "button4";
            this.button4.Size = new System.Drawing.Size(256, 23);
            this.button4.TabIndex = 5;
            this.button4.Text = "Good Evening";
            this.button4.Click += new System.EventHandler(this.button4_Click);
            // 
            // button3
            // 
            this.button3.Location = new System.Drawing.Point(16, 88);
            this.button3.Name = "button3";
            this.button3.Size = new System.Drawing.Size(256, 23);
            this.button3.TabIndex = 4;
            this.button3.Text = "Good Afternoon";
            this.button3.Click += new System.EventHandler(this.button3_Click);
            // 
            // button14
            // 
            this.button14.Location = new System.Drawing.Point(16, 24);
            this.button14.Name = "button14";
            this.button14.Size = new System.Drawing.Size(256, 23);
            this.button14.TabIndex = 16;
            this.button14.Text = "Create Example Database";
            this.button14.Click += new System.EventHandler(this.button14_Click);
            // 
            // textBox1
            // 
            this.textBox1.Location = new System.Drawing.Point(16, 64);
            this.textBox1.Name = "textBox1";
            this.textBox1.Size = new System.Drawing.Size(256, 20);
            this.textBox1.TabIndex = 10;
            this.textBox1.Text = "en-GB";
            // 
            // button1
            // 
            this.button1.Location = new System.Drawing.Point(16, 88);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(256, 23);
            this.button1.TabIndex = 11;
            this.button1.Text = "Set CurrentUICulture";
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // groupBox3
            // 
            this.groupBox3.Controls.Add(this.radioButtonResourceManager);
            this.groupBox3.Controls.Add(this.radioButtonTranslationResourceManager);
            this.groupBox3.Controls.Add(this.radioButtonResourcesResourceManager);
            this.groupBox3.Controls.Add(this.radioButtonDbResourceManager);
            this.groupBox3.Controls.Add(this.button15);
            this.groupBox3.Location = new System.Drawing.Point(296, 16);
            this.groupBox3.Name = "groupBox3";
            this.groupBox3.Size = new System.Drawing.Size(288, 120);
            this.groupBox3.TabIndex = 15;
            this.groupBox3.TabStop = false;
            this.groupBox3.Text = "ResourceManagerProvider.ResourceManagerType";
            // 
            // radioButtonResourceManager
            // 
            this.radioButtonResourceManager.Location = new System.Drawing.Point(16, 88);
            this.radioButtonResourceManager.Name = "radioButtonResourceManager";
            this.radioButtonResourceManager.Size = new System.Drawing.Size(152, 24);
            this.radioButtonResourceManager.TabIndex = 3;
            this.radioButtonResourceManager.Text = "ResourceManager";
            this.radioButtonResourceManager.CheckedChanged += new System.EventHandler(this.radioButtonResourceManager_CheckedChanged);
            // 
            // radioButtonTranslationResourceManager
            // 
            this.radioButtonTranslationResourceManager.Location = new System.Drawing.Point(16, 64);
            this.radioButtonTranslationResourceManager.Name = "radioButtonTranslationResourceManager";
            this.radioButtonTranslationResourceManager.Size = new System.Drawing.Size(176, 24);
            this.radioButtonTranslationResourceManager.TabIndex = 2;
            this.radioButtonTranslationResourceManager.Text = "TranslationResourceManager";
            this.radioButtonTranslationResourceManager.CheckedChanged += new System.EventHandler(this.radioButtonTranslationResourceManager_CheckedChanged);
            // 
            // radioButtonResourcesResourceManager
            // 
            this.radioButtonResourcesResourceManager.Location = new System.Drawing.Point(16, 40);
            this.radioButtonResourcesResourceManager.Name = "radioButtonResourcesResourceManager";
            this.radioButtonResourcesResourceManager.Size = new System.Drawing.Size(176, 24);
            this.radioButtonResourcesResourceManager.TabIndex = 1;
            this.radioButtonResourcesResourceManager.Text = "ResourcesResourceManager";
            this.radioButtonResourcesResourceManager.CheckedChanged += new System.EventHandler(this.radioButtonResourcesResourceManager_CheckedChanged);
            // 
            // radioButtonDbResourceManager
            // 
            this.radioButtonDbResourceManager.Checked = true;
            this.radioButtonDbResourceManager.Location = new System.Drawing.Point(16, 16);
            this.radioButtonDbResourceManager.Name = "radioButtonDbResourceManager";
            this.radioButtonDbResourceManager.Size = new System.Drawing.Size(160, 24);
            this.radioButtonDbResourceManager.TabIndex = 0;
            this.radioButtonDbResourceManager.Text = "DbResourceManager";
            this.radioButtonDbResourceManager.CheckedChanged += new System.EventHandler(this.radioButtonDbResourceManager_CheckedChanged);
            // 
            // button15
            // 
            this.button15.Location = new System.Drawing.Point(200, 24);
            this.button15.Name = "button15";
            this.button15.Size = new System.Drawing.Size(80, 23);
            this.button15.TabIndex = 17;
            this.button15.Text = "Show Form2";
            this.button15.Click += new System.EventHandler(this.button15_Click);
            // 
            // groupBox5
            // 
            this.groupBox5.Controls.Add(this.textBoxCurrentUICulture);
            this.groupBox5.Controls.Add(this.label1);
            this.groupBox5.Controls.Add(this.textBox1);
            this.groupBox5.Controls.Add(this.button1);
            this.groupBox5.Location = new System.Drawing.Point(8, 16);
            this.groupBox5.Name = "groupBox5";
            this.groupBox5.Size = new System.Drawing.Size(280, 120);
            this.groupBox5.TabIndex = 18;
            this.groupBox5.TabStop = false;
            this.groupBox5.Text = "CurrentUICulture";
            // 
            // textBoxCurrentUICulture
            // 
            this.textBoxCurrentUICulture.Location = new System.Drawing.Point(16, 32);
            this.textBoxCurrentUICulture.Name = "textBoxCurrentUICulture";
            this.textBoxCurrentUICulture.ReadOnly = true;
            this.textBoxCurrentUICulture.Size = new System.Drawing.Size(256, 20);
            this.textBoxCurrentUICulture.TabIndex = 1;
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(16, 16);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(100, 16);
            this.label1.TabIndex = 0;
            this.label1.Text = "CurrentUICulture";
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(920, 478);
            this.Controls.Add(this.groupBox5);
            this.Controls.Add(this.groupBox3);
            this.Controls.Add(this.groupBoxTranslationResourceManager);
            this.Controls.Add(this.groupBox2);
            this.Controls.Add(this.groupBox1);
            this.Name = "Form1";
            this.Text = "Custom Resource Managers Examples";
            this.groupBoxTranslationResourceManager.ResumeLayout(false);
            this.groupBox4.ResumeLayout(false);
            this.groupBox2.ResumeLayout(false);
            this.groupBox1.ResumeLayout(false);
            this.groupBox3.ResumeLayout(false);
            this.groupBox5.ResumeLayout(false);
            this.groupBox5.PerformLayout();
            this.ResumeLayout(false);

        }
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			System.Threading.Thread.CurrentThread.CurrentUICulture = new CultureInfo(textBox1.Text);
            ShowCurrentUICulture();
		}

        private bool CheckDatabaseExists()
        {
            if (DatabaseExists())
                return true;
            else
            {
                MessageBox.Show("The database does not exist. Use the option to create the database before using the DbResourceManager.");
                return false;
            }
        }

		private void button2_Click(object sender, System.EventArgs e)
		{
            if (CheckDatabaseExists())
            {
                DbResourceManager resourceManager = new DbResourceManager("CustomResourceManagersExample.Greetings");
                MessageBox.Show(resourceManager.GetString("GoodMorning"));
            }
		}

		private void button3_Click(object sender, System.EventArgs e)
		{
            if (CheckDatabaseExists())
            {
                DbResourceManager resourceManager = new DbResourceManager("CustomResourceManagersExample.Greetings");
                MessageBox.Show(resourceManager.GetString("GoodAfternoon"));
            }
		}

		private void button4_Click(object sender, System.EventArgs e)
		{
            if (CheckDatabaseExists())
            {
                DbResourceManager resourceManager = new DbResourceManager("CustomResourceManagersExample.Greetings");
                MessageBox.Show(resourceManager.GetString("GoodEvening"));
            }
		}

		private void button5_Click(object sender, System.EventArgs e)
		{
            if (CheckDatabaseExists())
            {
                DbResourceManager resourceManager = new DbResourceManager("CustomResourceManagersExample.Greetings");
                MessageBox.Show(resourceManager.GetString("GoodEvening"));
                MessageBox.Show(resourceManager.GetString("GoodEvening"));
            }
		}

		private void button6_Click(object sender, System.EventArgs e)
		{
			ResourcesResourceManager resourceManager = new ResourcesResourceManager("CustomResourceManagersExample.Greetings");
			MessageBox.Show(resourceManager.GetString("GoodMorning"));
		}

		private void button9_Click(object sender, System.EventArgs e)
		{
			ResourcesResourceManager resourceManager = new ResourcesResourceManager("CustomResourceManagersExample.Greetings");
			MessageBox.Show(resourceManager.GetString("GoodAfternoon"));
		}

		private void button8_Click(object sender, System.EventArgs e)
		{
			ResourcesResourceManager resourceManager = new ResourcesResourceManager("CustomResourceManagersExample.Greetings");
			MessageBox.Show(resourceManager.GetString("GoodEvening"));
		}

		private void button7_Click(object sender, System.EventArgs e)
		{
			ResourcesResourceManager resourceManager = new ResourcesResourceManager("CustomResourceManagersExample.Greetings");
			MessageBox.Show(resourceManager.GetString("GoodEvening"));
			MessageBox.Show(resourceManager.GetString("GoodEvening"));
		}

        private bool CheckTranslationManager()
        {
            if (TranslationResourceManager.ResourceManagerType == typeof(DbResourceManager))
                return CheckDatabaseExists();
            else
                return true;
        }

		private void button10_Click(object sender, System.EventArgs e)
		{
            if (CheckTranslationManager())
            {
                TranslationResourceManager resourceManager = new TranslationResourceManager("CustomResourceManagersExample.Greetings", Assembly.GetExecutingAssembly());
                MessageBox.Show(resourceManager.GetString("GoodMorning"));
            }
		}

		private void button13_Click(object sender, System.EventArgs e)
		{
            if (CheckTranslationManager())
            {
                TranslationResourceManager resourceManager = new TranslationResourceManager("CustomResourceManagersExample.Greetings", Assembly.GetExecutingAssembly());
                MessageBox.Show(resourceManager.GetString("GoodAfternoon"));
            }
		}

		private void button12_Click(object sender, System.EventArgs e)
		{
            if (CheckTranslationManager())
            {
                TranslationResourceManager resourceManager = new TranslationResourceManager("CustomResourceManagersExample.Greetings", Assembly.GetExecutingAssembly());
                MessageBox.Show(resourceManager.GetString("GoodEvening"));
            }
		}

		private void button11_Click(object sender, System.EventArgs e)
		{
            if (CheckTranslationManager())
            {
                TranslationResourceManager resourceManager = new TranslationResourceManager("CustomResourceManagersExample.Greetings", Assembly.GetExecutingAssembly());
                MessageBox.Show(resourceManager.GetString("GoodEvening"));
                MessageBox.Show(resourceManager.GetString("GoodEvening"));
            }
		}

		private void radioButtonDbResourceManager_CheckedChanged(object sender, System.EventArgs e)
		{
			ResourceManagerProvider.ResourceManagerType = typeof(DbResourceManager);
		}

		private void radioButtonResourcesResourceManager_CheckedChanged(object sender, System.EventArgs e)
		{
			ResourceManagerProvider.ResourceManagerType = typeof(ResourcesResourceManager);
		}

		private void radioButtonTranslationResourceManager_CheckedChanged(object sender, System.EventArgs e)
		{
			ResourceManagerProvider.ResourceManagerType = typeof(TranslationResourceManager);
		}

        /// <summary>
        /// DatabaseExists returns true if the database already exists
        /// </summary>
        /// <returns>True if the database already exists</returns>
        protected static bool DatabaseExists()
        {
            string databaseName = GetDatabaseName(DbResourceManager.ConnectionString);
            string query = 
                "IF EXISTS (SELECT name FROM master.dbo.sysdatabases WHERE name = @DatabaseName) " +
                "   SELECT 1; " + 
                "ELSE " +
                "   SELECT 0; ";

            string connectionString = RemoveDatabaseName(DbResourceManager.ConnectionString);
            using (SqlConnection connection = new SqlConnection(connectionString))
            {
                connection.Open();
                SqlCommand command = new SqlCommand(query, connection);
                command.Parameters.AddWithValue("@DatabaseName", databaseName);
                object result = command.ExecuteScalar();
                connection.Close();
                return result.ToString() == "1";
            }
        }
        /// <summary>
        /// RemoveDatabaseName removes the database name from a connection string
        /// </summary>
        /// <param name="connectionString">The connection string to remove the name from</param>
        /// <returns>A connection string with the database name removed</returns>
        protected static string RemoveDatabaseName(string connectionString)
        {
            connectionString = RemoveParameter("DATABASE", connectionString);
            connectionString = RemoveParameter("INITIAL CATALOG", connectionString);
            return connectionString;
        }
        /// <summary>
        /// RemoveParameter removes a parameter (and its value) from a connection string
        /// </summary>
        /// <param name="parameterName">The name of the parameter to remove</param>
        /// <param name="connectionString">The connection string to remove the parameter (and its value) from</param>
        /// <returns>The connection string with the parameter removed</returns>
        protected static string RemoveParameter(string parameterName, string connectionString)
        {
            int index = connectionString.ToUpper().IndexOf(parameterName + "=");
            if (index == -1)
                index = connectionString.ToUpper().IndexOf(parameterName + " =");
            if (index > -1)
            {
                int terminatorIndex = connectionString.IndexOf(";", index);
                if (terminatorIndex > -1)
                    connectionString = connectionString.Substring(0, index).TrimEnd() +
                        connectionString.Substring(terminatorIndex + 1).TrimEnd();
                else
                    connectionString = connectionString.Substring(0, index).TrimEnd();

            }
            return connectionString;
        }
        /// <summary>
        /// GetDatabaseName gets the name of the database from a connection string
        /// </summary>
        /// <param name="connectionString">The connection string to get the name from</param>
        /// <returns>The database name contained in the connection string</returns>
        protected static string GetDatabaseName(string connectionString)
        {
            string databaseName = GetParameter("DATABASE", connectionString);
            if (databaseName == null)
            {
                databaseName = GetParameter("INITIAL CATALOG", connectionString);
                if (databaseName == null)
                    return String.Empty;
            }
            return databaseName;
        }
        /// <summary>
        /// GetParameter gets the named parameter's value from a connection string
        /// </summary>
        /// <param name="parameterName">The name of the parameter to get the value of</param>
        /// <param name="connectionString">The connection string containing the parameter</param>
        /// <returns>The value of the parameter in the connection string</returns>
        protected static string GetParameter(string parameterName, string connectionString)
        {
            int equalsLength = 1;
            int index = connectionString.ToUpper().IndexOf(parameterName + "=");
            if (index == -1)
            {
                index = connectionString.ToUpper().IndexOf(parameterName + " =");
                equalsLength = 2;
            }
            if (index > -1)
            {
                string parameterValue = connectionString.Substring(index + parameterName.Length + equalsLength);
                int terminatorIndex = parameterValue.IndexOf(";");
                if (terminatorIndex > -1)
                    parameterValue = parameterValue.Substring(0, terminatorIndex);
                return parameterValue.Trim();
            }
            return null;
        }

		private void button14_Click(object sender, System.EventArgs e)
		{
            if (DatabaseExists())
                MessageBox.Show("The database already exists. To recreate the database you must manually delete it and select this option again.");
            else if (! File.Exists("Form2.resx") && ! File.Exists(@"..\..\Form2.resx"))
                MessageBox.Show("Form2.resx cannot be found. This file is required so that the contents can be exported to the database.");
			else if (MessageBox.Show("This option creates the CustomResourceManagersExample database, adds the ResourceSets table and adds data to it. Continue ?",
				"", MessageBoxButtons.YesNo) == DialogResult.Yes)
			{
                string path = CreateDatabase();
				CreateResourceSetsTable();
                MessageBox.Show(String.Format("Database created in {0}", path));
			}
		}
        private string CreateDatabase()
        {
            string path = null;
            string databaseName = GetDatabaseName(DbResourceManager.ConnectionString);
            string noDatabaseConnectionString = RemoveDatabaseName(DbResourceManager.ConnectionString);
            using (SqlConnection connection = new SqlConnection(noDatabaseConnectionString))
            {
                connection.Open();

                path = @"C:\" + databaseName + @"\";
                if (! Directory.Exists(path))
                    Directory.CreateDirectory(path);

                string dataFileName = path + databaseName + "_data.mdf";
                string logFileName = path + databaseName + "_log.ldf";
                string logName = databaseName + "_log";
                string createDatabaseCommandString =
                    "CREATE DATABASE [" + databaseName + "] ON PRIMARY" +
                    "(Name=" + databaseName +", filename = '" + dataFileName + "')log on" +
                    "(Name=" + logName +", filename='" + logFileName + "')";

                SqlCommand createDatabaseCommand = new SqlCommand(createDatabaseCommandString, connection);

                createDatabaseCommand.ExecuteNonQuery();

                connection.Close();
            }
            return path;
        }
		private void CreateResourceSetsTable()
		{
			SqlConnection connection = new SqlConnection(DbResourceManager.ConnectionString);
			connection.Open();
			try
			{
				SqlTransaction transaction = connection.BeginTransaction();
				try
				{
					string createCommandText = @"
					CREATE TABLE [ResourceSets] (
					[ResourceID] [int] IDENTITY (1, 1) NOT NULL ,
					[ResourceSetName] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
					[Culture] [nvarchar] (10) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
					[ResourceName] [nvarchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
					[ResourceValue] [nvarchar] (200) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
					[ResourceType] [nvarchar] (250) COLLATE SQL_Latin1_General_CP1_CI_AS ,
					CONSTRAINT [PK_ResourceSets] PRIMARY KEY  CLUSTERED 
					(
					[ResourceID]
					)  ON [PRIMARY] 
					) ON [PRIMARY]";

					SqlCommand createCommand = new SqlCommand(createCommandText, connection, transaction);
					createCommand.ExecuteNonQuery();

					InsertResourceString(connection, transaction, null   , "GoodMorning"  , "Hi");
					InsertResourceString(connection, transaction, "en"   , "GoodMorning"  , "Good Morning");
					InsertResourceString(connection, transaction, "en-GB", "GoodMorning"  , "What ho, old chap!");
					InsertResourceString(connection, transaction, null   , "GoodAfternoon", "Hi");
					InsertResourceString(connection, transaction, "en"   , "GoodAfternoon", "Good Afternoon");
					InsertResourceString(connection, transaction, null   , "GoodEvening"  , "Hi");

                    InsertForm(connection, transaction);

					transaction.Commit();
				}
				catch (SqlException sqlException)
				{
					transaction.Rollback();
					MessageBox.Show("SqlException: " + sqlException.Message);
				}
				catch
				{
					transaction.Rollback();
					throw;
				}
			}
			finally
			{
				connection.Close();
			}
		}
        private void InsertForm(SqlConnection connection, SqlTransaction transaction)
        {
            string fileName = "Form2.resx";
            if (! File.Exists(fileName))
                fileName = @"..\..\Form2.resx";
            ResourceSet resourceSet = new ResourceSet(new ResXResourceReader(fileName));
            foreach(DictionaryEntry entry in resourceSet)
            {
                InsertEntry("Form2", connection, transaction, null, entry);
            }
        }
        private void InsertEntry(
            string resourceSetName, SqlConnection connection, SqlTransaction transaction, CultureInfo culture, DictionaryEntry entry)
        {
            if (entry.Value != null)
            {
                string insertCommandText;
                if (culture == null)
                {
                    if (! (entry.Value is System.String))
                        insertCommandText = 
                        "INSERT INTO [ResourceSets]([ResourceSetName], [ResourceName], [ResourceValue], [ResourceType]) "+
                        "VALUES(@ResourceSetName, @ResourceName, @ResourceValue, @ResourceType)";
                    else
                        insertCommandText = 
                            "INSERT INTO [ResourceSets]([ResourceSetName], [ResourceName], [ResourceValue]) "+
                            "VALUES(@ResourceSetName, @ResourceName, @ResourceValue)";
                }
                else
                {
                    if (! (entry.Value is System.String))
                        insertCommandText = 
                        "INSERT INTO [ResourceSets]([ResourceSetName], [Culture], [ResourceName], [ResourceValue], [ResourceType]) "+
                        "VALUES(@ResourceSetName, @Culture, @ResourceName, @ResourceValue, @ResourceType)";
                    else
                        insertCommandText = 
                            "INSERT INTO [ResourceSets]([ResourceSetName], [Culture], [ResourceName], [ResourceValue]) "+
                            "VALUES(@ResourceSetName, @Culture, @ResourceName, @ResourceValue)";
                }

                using (SqlCommand insertCommand = new SqlCommand(insertCommandText, connection, transaction))
                {
                    insertCommand.Parameters.Add("@ResourceSetName", SqlDbType.NVarChar).Value = resourceSetName;
                    if (culture != null)
                        insertCommand.Parameters.Add("@Culture", SqlDbType.NVarChar).Value = culture;
                    insertCommand.Parameters.Add("@ResourceName", SqlDbType.NVarChar).Value = entry.Key.ToString();
                    insertCommand.Parameters.Add("@ResourceValue", SqlDbType.NVarChar).Value = ValueToString(entry.Value);
                    if (! (entry.Value is System.String))
                        insertCommand.Parameters.Add("@ResourceType", SqlDbType.NVarChar).Value = entry.Value.GetType().AssemblyQualifiedName;
                    insertCommand.ExecuteNonQuery();
                }
            }
        }
        private string ValueToString(object value)
        {
            if (value is Char)
                return value.ToString();

            TypeConverter typeConverter = TypeDescriptor.GetConverter(value.GetType());
            if (typeConverter.CanConvertTo(typeof(string)) && typeConverter.CanConvertFrom(typeof(string)))
                return typeConverter.ConvertToInvariantString(value);

            return value.ToString();
        }
        private void InsertResourceString(SqlConnection connection, SqlTransaction transaction, string culture, string resourceName, string resourceValue)
		{
			string insertCommandText;
			if (culture == null)
				insertCommandText = 
					"INSERT INTO [ResourceSets]([ResourceSetName], [ResourceName], [ResourceValue]) "+
					"VALUES(@ResourceSetName, @ResourceName, @ResourceValue)";
			else
				insertCommandText = 
					"INSERT INTO [ResourceSets]([ResourceSetName], [Culture], [ResourceName], [ResourceValue]) "+
					"VALUES(@ResourceSetName, @Culture, @ResourceName, @ResourceValue)";

            using (SqlCommand insertCommand = new SqlCommand(insertCommandText, connection, transaction))
            {
                insertCommand.Parameters.Add("@ResourceSetName", SqlDbType.NVarChar).Value = "CustomResourceManagersExample.Greetings";
                if (culture != null)
                    insertCommand.Parameters.Add("@Culture", SqlDbType.NVarChar).Value = culture;
                insertCommand.Parameters.Add("@ResourceName", SqlDbType.NVarChar).Value = resourceName;
                insertCommand.Parameters.Add("@ResourceValue", SqlDbType.NVarChar).Value = resourceValue;
                insertCommand.ExecuteNonQuery();
            }
		}

		private void radioButtonTRMDbResourceManager_CheckedChanged(object sender, System.EventArgs e)
		{
			TranslationResourceManager.ResourceManagerType = typeof(DbResourceManager);		
		}

		private void radioButtonTRMResourcesResourceManager_CheckedChanged(object sender, System.EventArgs e)
		{
			TranslationResourceManager.ResourceManagerType = typeof(ResourcesResourceManager);
		}

		private void radioButtonTRMResourceManager_CheckedChanged(object sender, System.EventArgs e)
		{
			TranslationResourceManager.ResourceManagerType = typeof(ResourcesResourceManager);
		}

		private void button15_Click(object sender, System.EventArgs e)
		{
            bool okToContinue;
            if (ResourceManagerProvider.ResourceManagerType == typeof(DbResourceManager))
                okToContinue = CheckDatabaseExists();
            else
                okToContinue = true;

            if (okToContinue)
            {
                Form2 form = new Form2();
                form.Show();
            }
		}

		private void radioButtonResourceManager_CheckedChanged(object sender, System.EventArgs e)
		{
			ResourceManagerProvider.ResourceManagerType = typeof(ResourceManager);
		}

	}
}
