﻿// File           : BaseResourceCodeGeneratorWithSiteWithoutCodeDom.cs
// Original Author: Guy Smith-Ferrier
// Date Created   : June 2008
// Notes          : This file is part of the downloadable source code for .NET Internationalization, by
//                  Guy Smith-Ferrier, published by Addison-Wesley. See http://www.dotneti18n.com for details.
// Disclaimer     : No warranty is provided. Use at your own risk.
// Modification   : You are free to modify this code providing that this block of comments is not altered
//                  and is placed before any code.
using Microsoft.VisualStudio;
using Microsoft.VisualStudio.Design;
using Microsoft.VisualStudio.OLE.Interop;
using Microsoft.VisualStudio.Shell;
using Microsoft.VisualStudio.Shell.Interop;
using System;
using System.CodeDom;
using System.Collections;
using System.Drawing;
using System.Globalization;
using System.IO;
using System.Resources;
using System.Resources.Tools;
using System.Runtime.InteropServices;
using System.Text;
using Microsoft.VisualStudio.Design.Serialization;

namespace Internationalization.VisualStudio.Design.Serialization
{
    public abstract class BaseResourceCodeGeneratorWithSiteWithoutCodeDom : BaseCodeGeneratorWithSiteWithoutCodeDom, IVsRefactorNotify
    {
        private IVsRefactorNotify refactorNotifyImplementer;
        private static Guid ResourceEditorRefactorNotifyService = new Guid("E7CEE0FD-FAE7-46b4-BD50-9D044BAC5A7C");

        int IVsRefactorNotify.OnAddParams(IVsHierarchy phier, uint itemId, string lpszRQName, uint cParams, uint[] rgszParamIndexes, string[] rgszRQTypeNames, string[] rgszParamNames)
        {
            if (this.RefactorNotifyImplementer != null)
            {
                return this.RefactorNotifyImplementer.OnAddParams(phier, itemId, lpszRQName, cParams, rgszParamIndexes, rgszRQTypeNames, rgszParamNames);
            }
            return -2147418113;
        }

        int IVsRefactorNotify.OnBeforeAddParams(IVsHierarchy phier, uint itemId, string lpszRQName, uint cParams, uint[] rgszParamIndexes, string[] rgszRQTypeNames, string[] rgszParamNames, out Array prgAdditionalCheckoutVSITEMIDS)
        {
            if (this.RefactorNotifyImplementer != null)
            {
                return this.RefactorNotifyImplementer.OnBeforeAddParams(phier, itemId, lpszRQName, cParams, rgszParamIndexes, rgszRQTypeNames, rgszParamNames, out prgAdditionalCheckoutVSITEMIDS);
            }
            prgAdditionalCheckoutVSITEMIDS = null;
            return -2147418113;
        }

        int IVsRefactorNotify.OnBeforeGlobalSymbolRenamed(IVsHierarchy phier, uint itemId, uint cRQNames, string[] rglpszRQName, string lpszNewName, out Array prgAdditionalCheckoutVSITEMIDS)
        {
            if (this.RefactorNotifyImplementer != null)
            {
                return this.RefactorNotifyImplementer.OnBeforeGlobalSymbolRenamed(phier, itemId, cRQNames, rglpszRQName, lpszNewName, out prgAdditionalCheckoutVSITEMIDS);
            }
            prgAdditionalCheckoutVSITEMIDS = null;
            return -2147418113;
        }

        int IVsRefactorNotify.OnBeforeRemoveParams(IVsHierarchy phier, uint itemId, string lpszRQName, uint cParamIndexes, uint[] rgParamIndexes, out Array prgAdditionalCheckoutVSITEMIDS)
        {
            if (this.RefactorNotifyImplementer != null)
            {
                return this.RefactorNotifyImplementer.OnBeforeRemoveParams(phier, itemId, lpszRQName, cParamIndexes, rgParamIndexes, out prgAdditionalCheckoutVSITEMIDS);
            }
            prgAdditionalCheckoutVSITEMIDS = null;
            return -2147418113;
        }

        int IVsRefactorNotify.OnBeforeReorderParams(IVsHierarchy phier, uint itemId, string lpszRQName, uint cParamIndexes, uint[] rgParamIndexes, out Array prgAdditionalCheckoutVSITEMIDS)
        {
            if (this.RefactorNotifyImplementer != null)
            {
                return this.RefactorNotifyImplementer.OnBeforeReorderParams(phier, itemId, lpszRQName, cParamIndexes, rgParamIndexes, out prgAdditionalCheckoutVSITEMIDS);
            }
            prgAdditionalCheckoutVSITEMIDS = null;
            return -2147418113;
        }

        int IVsRefactorNotify.OnGlobalSymbolRenamed(IVsHierarchy phier, uint itemId, uint cRQNames, string[] rglpszRQName, string lpszNewName)
        {
            if (this.RefactorNotifyImplementer != null)
            {
                return this.RefactorNotifyImplementer.OnGlobalSymbolRenamed(phier, itemId, cRQNames, rglpszRQName, lpszNewName);
            }
            return -2147418113;
        }

        int IVsRefactorNotify.OnRemoveParams(IVsHierarchy phier, uint itemId, string lpszRQName, uint cParamIndexes, uint[] rgParamIndexes)
        {
            if (this.RefactorNotifyImplementer != null)
            {
                return this.RefactorNotifyImplementer.OnRemoveParams(phier, itemId, lpszRQName, cParamIndexes, rgParamIndexes);
            }
            return -2147418113;
        }

        int IVsRefactorNotify.OnReorderParams(IVsHierarchy phier, uint itemId, string lpszRQName, uint cParamIndexes, uint[] rgParamIndexes)
        {
            if (this.RefactorNotifyImplementer != null)
            {
                return this.RefactorNotifyImplementer.OnReorderParams(phier, itemId, lpszRQName, cParamIndexes, rgParamIndexes);
            }
            return -2147418113;
        }

        private IVsRefactorNotify RefactorNotifyImplementer
        {
            get
            {
                if (this.refactorNotifyImplementer == null)
                {
                    Microsoft.VisualStudio.OLE.Interop.IServiceProvider globalService = Package.GetGlobalService(typeof(Microsoft.VisualStudio.OLE.Interop.IServiceProvider)) as Microsoft.VisualStudio.OLE.Interop.IServiceProvider;
                    if (globalService != null)
                    {
                        ServiceProvider provider2 = new ServiceProvider(globalService);
                        this.refactorNotifyImplementer = provider2.GetService(ResourceEditorRefactorNotifyService) as IVsRefactorNotify;
                    }
                }
                return this.refactorNotifyImplementer;
            }
        }
    }
}