// File           : PublicResourceCodeGenerator.cs
// Original Author: Guy Smith-Ferrier
// Date Created   : June 2008
// Notes          : This file is part of the downloadable source code for .NET Internationalization, by
//                  Guy Smith-Ferrier, published by Addison-Wesley. See http://www.dotneti18n.com for details.
// Disclaimer     : No warranty is provided. Use at your own risk.
// Modification   : You are free to modify this code providing that this block of comments is not altered
//                  and is placed before any code.
using System.Runtime.InteropServices;
using Resources.Tools;
using System.Collections;

namespace Internationalization.VisualStudio.Design.Serialization
{
    [Guid("B306F2E0-15F6-4746-8D7A-DE8549A35140")]
    public class PublicResourceCodeGenerator : ResourceCodeGenerator
    {
        protected override bool MakeClassInternal()
        {
            return false;
        }
        protected override System.CodeDom.CodeCompileUnit GenerateCodeCompileUnit(
            IDictionary resourceList, string fileNameWithoutExtension, string fileNameSpace,
            string resourcesNamespace, System.CodeDom.Compiler.CodeDomProvider codeProvider, bool internalClass,
            out string[] strArray)
        {
            // generate a strongly typed resource class CodeCompileUnit with the difference that the generated 
            // code statements have changed from an internal constructor to a public constructor e.g. from this:-
            //
            //         internal Strings() {}
            //
            // to this:-
            //
            //         public Strings() {}
            //
            // (This change is necessary for using strongly typed resource classes in Silverlight applications).
            return StronglyTypedResourceBuilderHelper.GenerateCodeCompileUnit(
                resourceList, fileNameWithoutExtension, resourcesNamespace, codeProvider, internalClass,
                out strArray, ResourceManagerGetStatementChange.Standard, false);
        }
    }
}

