// File           : ResourceProviderCodeGenerator.cs
// Original Author: Guy Smith-Ferrier
// Date Created   : June 2008
// Notes          : This file is part of the downloadable source code for .NET Internationalization, by
//                  Guy Smith-Ferrier, published by Addison-Wesley. See http://www.dotneti18n.com for details.
// Disclaimer     : No warranty is provided. Use at your own risk.
// Modification   : You are free to modify this code providing that this block of comments is not altered
//                  and is placed before any code.
using Microsoft.VisualStudio.Shell.Interop;
using System.Collections;
using System.Runtime.InteropServices;
using Resources.Tools;
namespace Internationalization.VisualStudio.Design.Serialization
{
    [Guid("7F109343-5D11-4abf-A87A-63C3F7D8792F")]
    public class ResourceProviderCodeGenerator : BaseResourceCodeGeneratorWithSite, IVsRefactorNotify
    {
        protected override System.CodeDom.CodeCompileUnit GenerateCodeCompileUnit(
            IDictionary resourceList, string fileNameWithoutExtension, string fileNameSpace,
            string resourcesNamespace, System.CodeDom.Compiler.CodeDomProvider codeProvider, bool internalClass,
            out string[] strArray)
        {
            // generate a strongly typed resource class CodeCompileUnit with the difference that the generated 
            // code statements have changed from:-
            // if ((resourceMan == null))
            // {
            //     System.Resources.ResourceManager temp = new System.Resources.ResourceManager("WindowsApplication2.strings", typeof(strings).Assembly);
            //     resourceMan = temp;
            // }
            // return resourceMan;
            //
            // to:-
            //
            // if ((resourceMan == null))
            // {
            //     System.Resources.ResourceManager temp = Internationalization.ResourceManagerProvider.GetResourceManager("WindowsApplication2.strings", typeof(strings).Assembly);
            //     resourceMan = temp;
            // }
            return StronglyTypedResourceBuilderHelper.GenerateCodeCompileUnit(
                resourceList, fileNameWithoutExtension, resourcesNamespace, codeProvider, internalClass,
                out strArray);
        }
    }
}