// File           : Form1.cs 
// Original Author: Guy Smith-Ferrier
// Date Created   : September 2005
// Notes          : This file is part of the downloadable source code for .NET Internationalization, by
//                  Guy Smith-Ferrier, published by Addison-Wesley. See http://www.dotneti18n.com for details.
// Disclaimer     : No warranty is provided. Use at your own risk.
// Modification   : You are free to modify this code providing that this block of comments is not altered
//                  and is placed before any code.
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Globalization;

namespace CultureInfoExExample
{
    public partial class Form1 : Form
    {
        /// <summary>
        /// Form1 is the main form
        /// </summary>
        public Form1()
        {
            InitializeComponent();

            CultureInfoEx cultureInfo = new CultureInfoEx("en-US");
            maskedTextBox1.Mask = cultureInfo.PostalCode.Mask;
        }

        private void radioButtonenUS_CheckedChanged(object sender, EventArgs e)
        {
            CultureInfoEx cultureInfo = new CultureInfoEx("en-US");
            maskedTextBox1.Mask = cultureInfo.PostalCode.Mask;
        }

        private void radioButtonenGB_CheckedChanged(object sender, EventArgs e)
        {
            CultureInfoEx cultureInfo = new CultureInfoEx("en-GB");
            maskedTextBox1.Mask = cultureInfo.PostalCode.Mask;
        }

        private void radioButtonenAU_CheckedChanged(object sender, EventArgs e)
        {
            CultureInfoEx cultureInfo = new CultureInfoEx("en-AU");
            maskedTextBox1.Mask = cultureInfo.PostalCode.Mask;
        }
    }
}