// File           : GoogleTranslator.cs
// Original Author: Guy Smith-Ferrier
// Date Created   : September 2005
// Notes          : This file is part of the downloadable source code for .NET Internationalization, by
//                  Guy Smith-Ferrier, published by Addison-Wesley. See http://www.dotneti18n.com for details.
// Disclaimer     : No warranty is provided. Use at your own risk.
// Modification   : You are free to modify this code providing that this block of comments is not altered
//                  and is placed before any code.
using System;

namespace Internationalization.Translation
{
	/// <summary>
	/// GoogleTranslator is a translator for the Google translator
	/// </summary>
	/// <remarks>
	/// This translator is now obsolete. Use GoogleTranslator.cs instead.
	/// Important: Read the Google Terms Of Service (http://www.google.com/terms_of_service.html) before using this translator.
	/// In particular the terms state "You may not send automated queries of any sort to Google's system without express 
	/// permission in advance from Google". You must obtain permission from Google before using this translator.
	/// </remarks>
	public class GoogleTranslator: HtmlTranslator
	{
		public GoogleTranslator(): base("Google Translator", @"http://translate.google.com/translate_t", new string[,]
				{
					{"en", "de"},
					{"en", "es"},
					{"en", "fr"},
					{"en", "it"},
					{"en", "pt"},
                    {"en", "ja"},
                    {"en", "ko"},
                    {"en", "zh-CN"},
                    {"de", "en"},
					{"de", "fr"},
					{"es", "en"},
					{"fr", "en"},
					{"fr", "de"},
					{"it", "en"},
					{"pt", "en"},
                    {"ja", "en"},
                    {"ko", "en"},
                    {"zh-CN", "en"}
                })
		{
		}
		public override string GetPostData(string inputLanguage, string outputLanguage, string text)
		{
			string languagePair = inputLanguage + "%7C" + outputLanguage;
			return "text=" + Encode(text) + "&langpair=" + languagePair + "&hl=en&ie=UTF-8&oe=UTF-8";
		}
		protected override string GetTranslation(string inputLanguage, string outputLanguage, string innerText)
		{
			string startingMarker = "This text has been automatically translated from ";
			int index = innerText.IndexOf(startingMarker);
			if (index == -1)
				return String.Empty;

            int colonIndex = innerText.IndexOf(":", index + startingMarker.Length);
            if (colonIndex == -1)
                return String.Empty;

			string translation = innerText.Substring(colonIndex + 5);
			index = translation.IndexOf("Translate text");
			if (index == -1)
				return String.Empty;

			return translation.Substring(0, index - 6);
		}
	}
}
