// File           : WebBrowserForm.cs
// Original Author: Guy Smith-Ferrier
// Date Created   : September 2005
// Notes          : This file is part of the downloadable source code for .NET Internationalization, by
//                  Guy Smith-Ferrier, published by Addison-Wesley. See http://www.dotneti18n.com for details.
// Disclaimer     : No warranty is provided. Use at your own risk.
// Modification   : You are free to modify this code providing that this block of comments is not altered
//                  and is placed before any code.
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace Internationalization.Translation
{
	/// <summary>
	/// WebBrowserForm is a Windows Form which holds a WebBrowser which is used to sending HTTP requests
	/// </summary>
	public class WebBrowserForm : System.Windows.Forms.Form
	{
        /// <summary>
        /// WebBrowser is the WebBrowser used for sending HTTP requests
        /// </summary>
		public WebBrowser WebBrowser;

        private System.ComponentModel.Container components = null;

        /// <summary>
        /// Constructs a WebBrowserForm object
        /// </summary>
		public WebBrowserForm()
		{
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.WebBrowser = new System.Windows.Forms.WebBrowser();
			this.SuspendLayout();
			// 
			// WebBrowser
			// 
			this.WebBrowser.Dock = System.Windows.Forms.DockStyle.Fill;
			this.WebBrowser.Location = new System.Drawing.Point(0, 0);
			this.WebBrowser.Name = "WebBrowser";
			this.WebBrowser.Size = new System.Drawing.Size(292, 266);
			this.WebBrowser.TabIndex = 1;
			// 
			// WebBrowserForm
			// 
			this.ClientSize = new System.Drawing.Size(292, 266);
			this.Controls.Add(this.WebBrowser);
			this.Name = "WebBrowserForm";
			this.Text = "WebBrowserForm";
			this.ResumeLayout(false);

		}
		#endregion

        /// <summary>
        /// WaitForBrowser waits for the browser's current operation to complete
        /// </summary>
		public void WaitForBrowser()
		{
			while(WebBrowser.ReadyState != WebBrowserReadyState.Complete) // SHDocVw.tagREADYSTATE.READYSTATE_COMPLETE)
			{
				Application.DoEvents();
			}
		}
	}
}
