// File           : ProgressForm.cs
// Original Author: Guy Smith-Ferrier
// Date Created   : September 2005
// Notes          : This file is part of the downloadable source code for .NET Internationalization, by
//                  Guy Smith-Ferrier, published by Addison-Wesley. See http://www.dotneti18n.com for details.
// Disclaimer     : No warranty is provided. Use at your own risk.
// Modification   : You are free to modify this code providing that this block of comments is not altered
//                  and is placed before any code.
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace Internationalization.ResourceAdministrator
{
	/// <summary>
	/// ProgressForm shows the progress of a long operation
	/// </summary>
	public class ProgressForm : System.Windows.Forms.Form
	{
        private System.Windows.Forms.ProgressBar progressBar;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

        /// <summary>
        /// Constructs a ProgressForm object
        /// </summary>
		public ProgressForm()
		{
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(ProgressForm));
            this.progressBar = new System.Windows.Forms.ProgressBar();
            this.SuspendLayout();
            // 
            // progressBar
            // 
            resources.ApplyResources(this.progressBar, "progressBar");
            this.progressBar.Name = "progressBar";
            // 
            // ProgressForm
            // 
            resources.ApplyResources(this, "$this");
            this.Controls.Add(this.progressBar);
            this.Name = "ProgressForm";
            this.ResumeLayout(false);

        }
		#endregion

        /// <summary>
        /// Maximum is the maximum extent of the progress bar
        /// </summary>
        public int Maximum
        {
            get {return progressBar.Maximum;}
            set {progressBar.Maximum = value;}
        }
        /// <summary>
        /// Value is the current value of the progress bar
        /// </summary>
        public int Value
        {
            get {return progressBar.Value;}
            set {progressBar.Value = value;}
        }
	}
}
