﻿using System;
using System.Collections.Generic;
using System.IO;
using Microsoft.Build.Framework;

namespace Silverlight.Build.Tasks
{
    public class XapResourcePackagerCreateOutputs : XapResourcePackagerBase
    {
        public override bool Execute()
        {
            if (String.IsNullOrEmpty(this.PackageCultures) || this.PackageCultures.Split(',').GetLength(0) == 0)
            {
                return true;
            }

            this.PackageCultures = this.PackageCultures.Replace(((char)10).ToString(), "");
            this.PackageCultures = this.PackageCultures.Replace(((char)13).ToString(), "");

            List<string> xapOutputFiles = new List<string>();
            foreach (string packageCulture in this.PackageCultures.Split(','))
            {
                if (!String.IsNullOrEmpty(packageCulture))
                {
                    string xapResourceFilename = String.Format("{0}.{1}.xap", this.XapFilenameWithoutExtension, packageCulture);
                    xapResourceFilename = Path.Combine(this.TargetDir, xapResourceFilename);
                    xapOutputFiles.Add(xapResourceFilename);
                }
            }

            this.XapOutputFiles = xapOutputFiles.ToArray();

            return true;
        }
    }
}
