﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ICSharpCode.SharpZipLib.Zip;
using System.IO;

namespace Silverlight.Build.Tasks
{
    public class ZipFileSharpZipLib
    {
        private ZipOutputStream zipOutputStream;

        public ZipFileSharpZipLib(string filename)
        {
            this.Filename = filename;
        }

        public string Filename { get; set; }

        public void Create()
        {
            zipOutputStream = new ZipOutputStream(File.Create(Filename));
            // Levels 0, 1, 2, 3, 4, 5, 6, 7, 8 and 9 don't work and not setting the level doesn't work either
            // zipOutputStream.SetLevel(9);
        }

        public void AddEntry(string entryName, byte[] entry)
        {
            ZipEntry zipEntry = new ZipEntry(entryName);

            zipOutputStream.PutNextEntry(zipEntry);

            zipOutputStream.Write(entry, 0, entry.Length);

            // zipOutputStream.CloseEntry();
        }

        public void AddFile(string file, string entryName)
        {
            FileStream fs = File.OpenRead(file);

            byte[] buffer = new byte[fs.Length];
            fs.Read(buffer, 0, buffer.Length);

            AddEntry(entryName, buffer);
        }

        public void Close()
        {
            zipOutputStream.Finish();
            zipOutputStream.Close();
        }
    }
}
