﻿// File           : DoNotConvertToUpperCase.cs 
// Original Author: Guy Smith-Ferrier
// Date Created   : April 2013
// Notes          : This file is part of the downloadable source code for .NET Internationalization, by
//                  Guy Smith-Ferrier, published by Addison-Wesley. See http://www.dotneti18n.com for details.
// Disclaimer     : No warranty is provided. Use at your own risk.
// Modification   : You are free to modify this code providing that this block of comments is not altered
//                  and is placed before any code.
using Microsoft.FxCop.Sdk;

namespace GlobalizationRules
{
    /// <summary>
    /// DoNotConvertToUpperCase is a rule to identify when String.ToUpper() is invoked
    /// </summary>
    public class DoNotConvertToUpperCase : DoNotUseMethod
    {
        /// <summary>
        /// Constructs an DoNotConvertToUpperCase object
        /// </summary>
        public DoNotConvertToUpperCase() :
            base("DoNotConvertToUpperCase", "System.String.ToUpper")
        {
        }
    }
}
