// File           : IntrospectionGlobalizationRule.cs
// Original Author: Guy Smith-Ferrier
// Date Created   : September 2005
// Notes          : This file is part of the downloadable source code for .NET Internationalization, by
//                  Guy Smith-Ferrier, published by Addison-Wesley. See http://www.dotneti18n.com for details.
// Disclaimer     : No warranty is provided. Use at your own risk.
// Modification   : You are free to modify this code providing that this block of comments is not altered
//                  and is placed before any code.
using Microsoft.FxCop.Sdk;
using System;

namespace LocalizationRules
{
    /// <summary>
    /// IntrospectionGlobalizationRule is an abstract base class for introspection globalization rules
    /// </summary>
    public abstract class IntrospectionGlobalizationRule : BaseIntrospectionRule
    {
        /// <summary>
        /// Constructs an IntrospectionGlobalizationRule object
        /// </summary>
        /// <param name="name">The name of the rule</param>
        protected IntrospectionGlobalizationRule(string name) : base(name, "LocalizationRules.RuleData", typeof(IntrospectionGlobalizationRule).Assembly)
        {
        }
    }
}
