// File           : ThreadNotProvidedByFactory.cs
// Original Author: Guy Smith-Ferrier
// Date Created   : September 2005
// Notes          : This file is part of the downloadable source code for .NET Internationalization, by
//                  Guy Smith-Ferrier, published by Addison-Wesley. See http://www.dotneti18n.com for details.
// Disclaimer     : No warranty is provided. Use at your own risk.
// Modification   : You are free to modify this code providing that this block of comments is not altered
//                  and is placed before any code.
using System;

namespace GlobalizationRules
{
    /// <summary>
    /// ThreadNotProvidedByFactory checks that Thread objects are created by the ThreadFactory class
    /// </summary>
    public class ThreadNotProvidedByFactory: ObjectNotProvidedByProvider
    {
        /// <summary>
        /// Constructs a ThreadNotProvidedByFactory object
        /// </summary>
        public ThreadNotProvidedByFactory(): base(
            "ThreadNotProvidedByFactory",
            "System.Threading.Thread",
            "Internationalization.Common.ThreadFactory")
        {
        }
    }
}
