// File           : FindDialog.cs
// Original Author: Guy Smith-Ferrier
// Date Created   : September 2005
// Notes          : This file is part of the downloadable source code for .NET Internationalization, by
//                  Guy Smith-Ferrier, published by Addison-Wesley. See http://www.dotneti18n.com for details.
// Disclaimer     : No warranty is provided. Use at your own risk.
// Modification   : You are free to modify this code providing that this block of comments is not altered
//                  and is placed before any code.
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace ResourceTranslationManager
{
    /// <summary>
    /// FindDialog is used to get a value to find
    /// </summary>
    public partial class FindDialog : Form
    {
        /// <summary>
        /// Constructs a FindDialog object
        /// </summary>
        public FindDialog()
        {
            InitializeComponent();
        }
        /// <summary>
        /// Constructs a FindDialog object
        /// </summary>
        /// <param name="findCategoryCaption">The caption for the find category</param>
        /// <param name="findValue">The initial value to offer for finding</param>
        public FindDialog(string findCategoryCaption, string findValue)
        {
            InitializeComponent();
            FindCategoryCaption = findCategoryCaption;
            FindValue = findValue;
        }
        /// <summary>
        /// FindCategoryCaption is the caption for the find category
        /// </summary>
        public string FindCategoryCaption
        {
            get { return labelFind.Text; }
            set { labelFind.Text = value; }
        }
        /// <summary>
        /// FindValue is the initial value to offer for findin
        /// </summary>
        public string FindValue
        {
            get { return textBoxFind.Text; }
            set { textBoxFind.Text = value; }
        }
    }
}