// File           : Form1.cs
// Original Author: Guy Smith-Ferrier
// Date Created   : September 2005
// Notes          : This file is part of the downloadable source code for .NET Internationalization, by
//                  Guy Smith-Ferrier, published by Addison-Wesley. See http://www.dotneti18n.com for details.
// Disclaimer     : No warranty is provided. Use at your own risk.
// Modification   : You are free to modify this code providing that this block of comments is not altered
//                  and is placed before any code.
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Threading;
using System.Reflection;
using System.Runtime.InteropServices;
using System.Globalization;
using Internationalization.Windows.Forms;

namespace ChangeFormCulturesDuringExecution
{
	/// <summary>
    /// Form1 provides an example of how to change cultures during execution using the operating system's 
    /// Regional and Language Options dialog
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.Windows.Forms.MenuItem menuItem4;
		private System.Windows.Forms.MenuItem menuItem5;
		private System.Windows.Forms.MenuItem menuItem11;
		private System.Windows.Forms.MenuItem menuItem12;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.Button button1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

        /// <summary>
        /// Constructs a Form1 object
        /// </summary>
		public Form1()
		{
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
            this.mainMenu1 = new System.Windows.Forms.MainMenu();
            this.menuItem1 = new System.Windows.Forms.MenuItem();
            this.menuItem2 = new System.Windows.Forms.MenuItem();
            this.menuItem3 = new System.Windows.Forms.MenuItem();
            this.menuItem4 = new System.Windows.Forms.MenuItem();
            this.menuItem5 = new System.Windows.Forms.MenuItem();
            this.menuItem11 = new System.Windows.Forms.MenuItem();
            this.menuItem12 = new System.Windows.Forms.MenuItem();
            this.label1 = new System.Windows.Forms.Label();
            this.textBox1 = new System.Windows.Forms.TextBox();
            this.button1 = new System.Windows.Forms.Button();
            this.SuspendLayout();
            // 
            // mainMenu1
            // 
            this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                      this.menuItem1,
                                                                                      this.menuItem11});
            this.mainMenu1.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("mainMenu1.RightToLeft")));
            // 
            // menuItem1
            // 
            this.menuItem1.Enabled = ((bool)(resources.GetObject("menuItem1.Enabled")));
            this.menuItem1.Index = 0;
            this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                      this.menuItem2,
                                                                                      this.menuItem3,
                                                                                      this.menuItem4,
                                                                                      this.menuItem5});
            this.menuItem1.Shortcut = ((System.Windows.Forms.Shortcut)(resources.GetObject("menuItem1.Shortcut")));
            this.menuItem1.ShowShortcut = ((bool)(resources.GetObject("menuItem1.ShowShortcut")));
            this.menuItem1.Text = resources.GetString("menuItem1.Text");
            this.menuItem1.Visible = ((bool)(resources.GetObject("menuItem1.Visible")));
            // 
            // menuItem2
            // 
            this.menuItem2.Enabled = ((bool)(resources.GetObject("menuItem2.Enabled")));
            this.menuItem2.Index = 0;
            this.menuItem2.Shortcut = ((System.Windows.Forms.Shortcut)(resources.GetObject("menuItem2.Shortcut")));
            this.menuItem2.ShowShortcut = ((bool)(resources.GetObject("menuItem2.ShowShortcut")));
            this.menuItem2.Text = resources.GetString("menuItem2.Text");
            this.menuItem2.Visible = ((bool)(resources.GetObject("menuItem2.Visible")));
            // 
            // menuItem3
            // 
            this.menuItem3.Enabled = ((bool)(resources.GetObject("menuItem3.Enabled")));
            this.menuItem3.Index = 1;
            this.menuItem3.Shortcut = ((System.Windows.Forms.Shortcut)(resources.GetObject("menuItem3.Shortcut")));
            this.menuItem3.ShowShortcut = ((bool)(resources.GetObject("menuItem3.ShowShortcut")));
            this.menuItem3.Text = resources.GetString("menuItem3.Text");
            this.menuItem3.Visible = ((bool)(resources.GetObject("menuItem3.Visible")));
            // 
            // menuItem4
            // 
            this.menuItem4.Enabled = ((bool)(resources.GetObject("menuItem4.Enabled")));
            this.menuItem4.Index = 2;
            this.menuItem4.Shortcut = ((System.Windows.Forms.Shortcut)(resources.GetObject("menuItem4.Shortcut")));
            this.menuItem4.ShowShortcut = ((bool)(resources.GetObject("menuItem4.ShowShortcut")));
            this.menuItem4.Text = resources.GetString("menuItem4.Text");
            this.menuItem4.Visible = ((bool)(resources.GetObject("menuItem4.Visible")));
            // 
            // menuItem5
            // 
            this.menuItem5.Enabled = ((bool)(resources.GetObject("menuItem5.Enabled")));
            this.menuItem5.Index = 3;
            this.menuItem5.Shortcut = ((System.Windows.Forms.Shortcut)(resources.GetObject("menuItem5.Shortcut")));
            this.menuItem5.ShowShortcut = ((bool)(resources.GetObject("menuItem5.ShowShortcut")));
            this.menuItem5.Text = resources.GetString("menuItem5.Text");
            this.menuItem5.Visible = ((bool)(resources.GetObject("menuItem5.Visible")));
            // 
            // menuItem11
            // 
            this.menuItem11.Enabled = ((bool)(resources.GetObject("menuItem11.Enabled")));
            this.menuItem11.Index = 1;
            this.menuItem11.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                       this.menuItem12});
            this.menuItem11.Shortcut = ((System.Windows.Forms.Shortcut)(resources.GetObject("menuItem11.Shortcut")));
            this.menuItem11.ShowShortcut = ((bool)(resources.GetObject("menuItem11.ShowShortcut")));
            this.menuItem11.Text = resources.GetString("menuItem11.Text");
            this.menuItem11.Visible = ((bool)(resources.GetObject("menuItem11.Visible")));
            // 
            // menuItem12
            // 
            this.menuItem12.Enabled = ((bool)(resources.GetObject("menuItem12.Enabled")));
            this.menuItem12.Index = 0;
            this.menuItem12.Shortcut = ((System.Windows.Forms.Shortcut)(resources.GetObject("menuItem12.Shortcut")));
            this.menuItem12.ShowShortcut = ((bool)(resources.GetObject("menuItem12.ShowShortcut")));
            this.menuItem12.Text = resources.GetString("menuItem12.Text");
            this.menuItem12.Visible = ((bool)(resources.GetObject("menuItem12.Visible")));
            // 
            // label1
            // 
            this.label1.AccessibleDescription = resources.GetString("label1.AccessibleDescription");
            this.label1.AccessibleName = resources.GetString("label1.AccessibleName");
            this.label1.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("label1.Anchor")));
            this.label1.AutoSize = ((bool)(resources.GetObject("label1.AutoSize")));
            this.label1.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("label1.Dock")));
            this.label1.Enabled = ((bool)(resources.GetObject("label1.Enabled")));
            this.label1.Font = ((System.Drawing.Font)(resources.GetObject("label1.Font")));
            this.label1.Image = ((System.Drawing.Image)(resources.GetObject("label1.Image")));
            this.label1.ImageAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("label1.ImageAlign")));
            this.label1.ImageIndex = ((int)(resources.GetObject("label1.ImageIndex")));
            this.label1.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("label1.ImeMode")));
            this.label1.Location = ((System.Drawing.Point)(resources.GetObject("label1.Location")));
            this.label1.Name = "label1";
            this.label1.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("label1.RightToLeft")));
            this.label1.Size = ((System.Drawing.Size)(resources.GetObject("label1.Size")));
            this.label1.TabIndex = ((int)(resources.GetObject("label1.TabIndex")));
            this.label1.Text = resources.GetString("label1.Text");
            this.label1.TextAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("label1.TextAlign")));
            this.label1.Visible = ((bool)(resources.GetObject("label1.Visible")));
            // 
            // textBox1
            // 
            this.textBox1.AccessibleDescription = resources.GetString("textBox1.AccessibleDescription");
            this.textBox1.AccessibleName = resources.GetString("textBox1.AccessibleName");
            this.textBox1.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("textBox1.Anchor")));
            this.textBox1.AutoSize = ((bool)(resources.GetObject("textBox1.AutoSize")));
            this.textBox1.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("textBox1.BackgroundImage")));
            this.textBox1.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("textBox1.Dock")));
            this.textBox1.Enabled = ((bool)(resources.GetObject("textBox1.Enabled")));
            this.textBox1.Font = ((System.Drawing.Font)(resources.GetObject("textBox1.Font")));
            this.textBox1.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("textBox1.ImeMode")));
            this.textBox1.Location = ((System.Drawing.Point)(resources.GetObject("textBox1.Location")));
            this.textBox1.MaxLength = ((int)(resources.GetObject("textBox1.MaxLength")));
            this.textBox1.Multiline = ((bool)(resources.GetObject("textBox1.Multiline")));
            this.textBox1.Name = "textBox1";
            this.textBox1.PasswordChar = ((char)(resources.GetObject("textBox1.PasswordChar")));
            this.textBox1.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("textBox1.RightToLeft")));
            this.textBox1.ScrollBars = ((System.Windows.Forms.ScrollBars)(resources.GetObject("textBox1.ScrollBars")));
            this.textBox1.Size = ((System.Drawing.Size)(resources.GetObject("textBox1.Size")));
            this.textBox1.TabIndex = ((int)(resources.GetObject("textBox1.TabIndex")));
            this.textBox1.Text = resources.GetString("textBox1.Text");
            this.textBox1.TextAlign = ((System.Windows.Forms.HorizontalAlignment)(resources.GetObject("textBox1.TextAlign")));
            this.textBox1.Visible = ((bool)(resources.GetObject("textBox1.Visible")));
            this.textBox1.WordWrap = ((bool)(resources.GetObject("textBox1.WordWrap")));
            // 
            // button1
            // 
            this.button1.AccessibleDescription = resources.GetString("button1.AccessibleDescription");
            this.button1.AccessibleName = resources.GetString("button1.AccessibleName");
            this.button1.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("button1.Anchor")));
            this.button1.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("button1.BackgroundImage")));
            this.button1.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("button1.Dock")));
            this.button1.Enabled = ((bool)(resources.GetObject("button1.Enabled")));
            this.button1.FlatStyle = ((System.Windows.Forms.FlatStyle)(resources.GetObject("button1.FlatStyle")));
            this.button1.Font = ((System.Drawing.Font)(resources.GetObject("button1.Font")));
            this.button1.Image = ((System.Drawing.Image)(resources.GetObject("button1.Image")));
            this.button1.ImageAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("button1.ImageAlign")));
            this.button1.ImageIndex = ((int)(resources.GetObject("button1.ImageIndex")));
            this.button1.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("button1.ImeMode")));
            this.button1.Location = ((System.Drawing.Point)(resources.GetObject("button1.Location")));
            this.button1.Name = "button1";
            this.button1.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("button1.RightToLeft")));
            this.button1.Size = ((System.Drawing.Size)(resources.GetObject("button1.Size")));
            this.button1.TabIndex = ((int)(resources.GetObject("button1.TabIndex")));
            this.button1.Text = resources.GetString("button1.Text");
            this.button1.TextAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("button1.TextAlign")));
            this.button1.Visible = ((bool)(resources.GetObject("button1.Visible")));
            // 
            // Form1
            // 
            this.AccessibleDescription = resources.GetString("$this.AccessibleDescription");
            this.AccessibleName = resources.GetString("$this.AccessibleName");
            this.AutoScroll = ((bool)(resources.GetObject("$this.AutoScroll")));
            this.AutoScrollMargin = ((System.Drawing.Size)(resources.GetObject("$this.AutoScrollMargin")));
            this.AutoScrollMinSize = ((System.Drawing.Size)(resources.GetObject("$this.AutoScrollMinSize")));
            this.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("$this.BackgroundImage")));
            this.ClientSize = ((System.Drawing.Size)(resources.GetObject("$this.ClientSize")));
            this.Controls.Add(this.button1);
            this.Controls.Add(this.textBox1);
            this.Controls.Add(this.label1);
            this.Enabled = ((bool)(resources.GetObject("$this.Enabled")));
            this.Font = ((System.Drawing.Font)(resources.GetObject("$this.Font")));
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("$this.ImeMode")));
            this.Location = ((System.Drawing.Point)(resources.GetObject("$this.Location")));
            this.MaximumSize = ((System.Drawing.Size)(resources.GetObject("$this.MaximumSize")));
            this.Menu = this.mainMenu1;
            this.MinimumSize = ((System.Drawing.Size)(resources.GetObject("$this.MinimumSize")));
            this.Name = "Form1";
            this.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("$this.RightToLeft")));
            this.StartPosition = ((System.Windows.Forms.FormStartPosition)(resources.GetObject("$this.StartPosition")));
            this.Text = resources.GetString("$this.Text");
            this.ResumeLayout(false);

        }
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

        /// <summary>
        /// GetUserDefaultLCID is a Win32 function that gets the LCID of the operating system
        /// </summary>
        /// <returns></returns>
        [DllImport("kernel32.dll")]
        protected static extern int GetUserDefaultLCID();
        private const int WM_SETTINGSCHANGE = 0x001A;
        /// <summary>
        /// WndProc is the windows message handler
        /// </summary>
        /// <param name="message">The message</param>
        protected override void WndProc(ref Message message)
        {
            switch (message.Msg)
            {
                case WM_SETTINGSCHANGE:
                {
                    if ((int) message.WParam == 0 && message.LParam != IntPtr.Zero
                        && Marshal.PtrToStringAuto(message.LParam) == "intl")
                    {
                        if (Thread.CurrentThread.CurrentCulture.LCID != GetUserDefaultLCID())
                        {
                            Thread.CurrentThread.CurrentCulture = new CultureInfo(GetUserDefaultLCID());
                            Thread.CurrentThread.CurrentUICulture = Thread.CurrentThread.CurrentCulture;
                            ChangeFormCulture.ChangeAllForms(Thread.CurrentThread.CurrentUICulture.Name);
                        }
                        else
                        {
                            Thread.CurrentThread.CurrentCulture.ClearCachedData();
                            Thread.CurrentThread.CurrentUICulture.ClearCachedData();
                        }
                    }
                    break;
                }
            }
            base.WndProc(ref message);
        }

	}
}
