// File           : Form1.cs
// Original Author: Guy Smith-Ferrier
// Date Created   : September 2006
// Notes          : This file is part of the downloadable source code for .NET Internationalization, by
//                  Guy Smith-Ferrier, published by Addison-Wesley. See http://www.dotneti18n.com for details.
// Disclaimer     : No warranty is provided. Use at your own risk.
// Modification   : You are free to modify this code providing that this block of comments is not altered
//                  and is placed before any code.
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Globalization;
using System.Threading;
using System.Drawing.Printing;

namespace SchizophrenicUI
{
    public partial class Form1 : Form
    {
        /// <summary>
        /// Form1 provides an example of a schizophrenic user interface
        /// </summary>
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            colorDialog1.ShowDialog();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            folderBrowserDialog1.ShowDialog();
        }

        private void button3_Click(object sender, EventArgs e)
        {
            fontDialog1.ShowDialog();
        }

        private void button4_Click(object sender, EventArgs e)
        {
            MessageBox.Show(Form1Resources.MessageBoxMessage, Form1Resources.MessageBoxCaption, MessageBoxButtons.YesNoCancel, MessageBoxIcon.Exclamation);
        }

        private void button5_Click(object sender, EventArgs e)
        {
            openFileDialog1.ShowDialog();
        }

        private void button6_Click(object sender, EventArgs e)
        {
            pageSetupDialog1.ShowDialog();
        }

        private void button7_Click(object sender, EventArgs e)
        {
            printDialog1.ShowDialog();
        }

        private void button8_Click(object sender, EventArgs e)
        {
            saveFileDialog1.ShowDialog();
        }

        private PrintPreviewDialog PrintPreviewDialog1;
        private PrintDocument printDocument = new PrintDocument();

        private void button9_Click(object sender, EventArgs e)
        {
            this.printDocument.PrintPage += new System.Drawing.Printing.PrintPageEventHandler(document_PrintPage);


            PrintPreviewDialog1 = new PrintPreviewDialog();
            PrintPreviewDialog1.Document = printDocument;
            PrintPreviewDialog1.ShowDialog();
        }

        private void document_PrintPage(object sender, System.Drawing.Printing.PrintPageEventArgs e)
        {
            //string text = "In document_PrintPage method.";
            //System.Drawing.Font printFont = new System.Drawing.Font("Arial", 35, System.Drawing.FontStyle.Regular);

            //e.Graphics.DrawString(text, printFont, System.Drawing.Brushes.Black, 0, 0);
        }
    }
}